Project/my_app/config/routes.rb
Rails.application.routes.draw do
  resources :credit_cards
  resources :orders
  resources :categories
  resources :products
  resources :addresses
  resources :credit_cards
  devise_for :users , controllers: { registrations: 'user/registrations' }

  root 'home#home'

  get 'goodbye', to: 'application#goodbye'

  get 'extra', to: 'application#extra'

  get 'test', to: 'application#test'

  get 'log_out', to: 'extra#new'

  get 'accounts', to: 'users#index', as: 'users'

  get 'profile', to: 'users#show'

end

Project/my_app/app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_one :address
  has_one :credit_card
  accepts_nested_attributes_for :address
  has_many :orders
  has_one_attached :image

  def admin?
    self.role == "admin"
  end
end

Project/my_app/app/controllers/user/confirmations_controller.rb
# frozen_string_literal: true

class User::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

Project/my_app/app/controllers/user/omniauth_callbacks_controller.rb
# frozen_string_literal: true

class User::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/heartcombo/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

Project/my_app/app/controllers/user/passwords_controller.rb
# frozen_string_literal: true

class User::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

Project/my_app/app/controllers/user/registrations_controller.rb
# frozen_string_literal: true

class User::RegistrationsController < Devise::RegistrationsController
  before_action :configure_sign_up_params, only: [:create]
  before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  def new
    super
    resource.build_address

  end

  # POST /resource
  def create
    super
  end

  # GET /resource/edit
  def edit
    super
  end

  # PUT /resource
  def update
   super
  end

  # DELETE /resource
  def destroy
    super
  end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel OAuth signing in/up in the middle of the process,
  # removing all OAuth session data.
  def cancel
    super
  end

  protected

  # If you have extra params to permit, append them to the sanitizer.
  def configure_sign_up_params
    devise_parameter_sanitizer.permit(:sign_up, keys: [:image, :name, address_attributes: [:city, :street, :housenr, :flat, :floor, :aptnr]])
  end

  # If you have extra params to permit, append them to the sanitizer.
  def configure_account_update_params
    devise_parameter_sanitizer.permit(:account_update, keys: [:image, :name, address_attributes: [:city, :street, :housenr, :flat, :floor, :aptnr]])
  end

  # The path used after sign up.
  def after_sign_up_path_for(resource)
    super(resource)
  end

  # The path used after sign up for inactive accounts.
  def after_inactive_sign_up_path_for(resource)
    super(resource)
  end
end

Project/my_app/app/controllers/user/sessions_controller.rb
# frozen_string_literal: true

class User::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

Project/my_app/app/controllers/user/unlocks_controller.rb
# frozen_string_literal: true

class User::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

Project/my_app/app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :check_admin, except: [:show, :update]
  before_action :authenticate_user!

  include Pagy::Backend

  def index
    @users = User.all
    @pagy, @users = pagy(@users)
  end

  def show
    @user = current_user
    @credit_card = @user.credit_card
  end

end

Project/my_app/app/helpers/user_helper.rb
module UserHelper
end

Project/my_app/app/helpers/users_helper.rb
module UsersHelper
end

Project/my_app/app/views/users/index.html.erb
<%= javascript_include_tag 'mdb' %>

<link rel="preconnect" href="https://fonts.gstatic.com">
<link href="https://fonts.googleapis.com/css2?family=Anton&display=swap" rel="stylesheet">

<body style="background-color: #E0E0E0; height: 100vh; margin: 0; padding: 0;">
<div class="container mt-5">
  <h2 style="font-family: 'Anton', sans-serif;">Users</h2>
  <br>
  <%== pagy_info(@pagy) %>
  <br>
  <br>
  <table class="table table-info table-striped table-dark">
      <thead>
        <tr>
          <th scope="col">ID</th>
          <th scope="col">Name</th>
          <th scope="col">E-mail</th>
          <th scope="col">Role</th>
          <th scope="col">Creation Date</th>
        </tr>
      </thead>
      <tbody>
        <% @users.each do |user| %>
          <tr>
            <td><%= user.id %></td>
            <td><%= user.name %></td>
            <td><%= user.email %></td>
            <td><%= user.role %></td>
            <td><%= user.created_at%></td>
          </tr>
        <% end %>
      </tbody>
    </table>
    <%== pagy_nav(@pagy) if @pagy.pages > 1 %>
</div>
</body>

<footer class="text-center text-white mt-4 fixed-bottom">
  <div class="text-center p-2" style="background-color: #332d2d; color: #FFFFFF;">
      © 2023 Basketball Haven
  </div>
</footer>

Project/my_app/app/views/users/new.html.erb
<h1>Users#new</h1>
<p>Find me in app/views/users/new.html.erb</p>

Project/my_app/app/views/users/show.html.erb
<%= javascript_include_tag 'mdb' %>

<body style="background-color: #E0E0E0; display: flex; flex-direction: column; min-height: 100vh; margin: 0; padding: 0;">
  <section class="d-flex justify-content-center align-items-center flex-grow-1">
    <div class="card-deck mb-10">
      <div class="card" style="width: 550px; background-color: #332d2d;">
        <div class="card-body text-center">
          <% if @user.image.present? %>
            <%= image_tag @user.image, alt: 'avatar', class: 'rounded-circle img-fluid', style: 'width: 150px;' %>
          <% else %>
            <img src="https://mdbcdn.b-cdn.net/img/Photos/new-templates/bootstrap-chat/ava3.webp" alt="avatar" class="rounded-circle img-fluid" style="width: 150px;">
          <% end %>
          <h5 class="my-3 text-center", style="color: white;"><%= @user.name %></h5>
          <p class="mb-1 text-center", style="color: #b3b3b3;"><%= @user.email %></p>
          <div class="d-flex justify-content-center mt-2">
            <%= link_to 'Edit profile', edit_user_registration_path, class: 'btn btn-primary' %>
          </div>
        </div>
      </div>
      <br>
      <div class="card" style="background-color: #332d2d;">
        <div class="card-body">
          <br>
          <div class="row">
            <div class="col-sm-6">
              <p class="mb-0 text-center", style="color: white;">Credit card nr.</p>
            </div>
            <div class="col-sm-6">
              <% if @user.credit_card %>
                <% credit_card_number = @user.credit_card.creditnr.to_s %>
                <% masked_number = '*' * (credit_card_number.length - 4) + credit_card_number[-4, 4] %>
                <p class="mb-0 text-center", style="color: #b3b3b3;"><%= masked_number %></p>
              <% else %>
                <p class="mb-0 text-center", style="color: #b3b3b3;">None</p>
              <% end %>
            </div>
            <div class="col-sm-6 mt-2">
              <p class="mb-0 text-center", style="color: white;">Exp. date</p>
            </div>
            <div class="col-sm-6 mt-2">
              <% if @user.credit_card %>
                <p class="mb-0 text-center", style="color: #b3b3b3;"><%= @user.credit_card.expday %>/<%= @user.credit_card.expmonth %>/<%= @user.credit_card.expyear %></p>
              <% else %>
                <p class="mb-0 text-center", style="color: #b3b3b3;">None</p>
              <% end %>
            </div>
          </div>
          <br>
          <% if @user.credit_card %>
          <div class="d-flex justify-content-center mb-2">
            <%= link_to 'Edit Credit Card', edit_credit_card_path(@user.credit_card), class: "btn btn-primary"%>
          </div>
          <% else %>
          <div class="d-flex justify-content-center mb-2">
            <%= link_to 'Add Credit Card', new_credit_card_path(@user.credit_card), class: "btn btn-primary"%>
          </div>
          <% end %>
          <hr>
          <div class="row">
            <div class="col-sm-6">
              <p class="mb-0 text-center", style="color: white;">Address</p>
            </div>
            <div class="col-sm-6">
            <% if @user.address %>
              <p class="mb-0 text-center", style="color: #b3b3b3;"><%= @user.address.city %>, Str. <%= @user.address.street %>, Nr. <%= @user.address.housenr %></p>
            <% else %>
              <p class="mb-0 text-center", style="color: #b3b3b3;">None</p>
            <% end %>
            </div>
            <br>
            <br>
            <% if @user.address %>
              <div class="d-flex justify-content-center mb-2">
              <%= link_to 'Edit Address', edit_address_path(@user.address), class: "btn btn-primary"%>
              </div>
            <% end %>
          </div>
        </div>
      </div>
    </div>
  </section>

  <footer class="text-center text-white mt-4 fixed-bottom">
    <div class="text-center p-2" style="background-color: #332d2d; color: #FFFFFF;">
      © 2023 Basketball Haven
    </div>
  </footer>
</body>